"Name:		SmallInterfaces Squeak Util
Date:			20 May 2000
Author:			Masashi Umezawa
Version:	2.0.0
Distribution:	World
Prerequisites: #('' )
Description:

Utility classes for SmallInterfaces Squeak implementation.

Copyright (C) 2000 Masashi Umezawa

URL: http://brain.cs.uiuc.edu/VisualWorks/SmallInterfaces (original)
URL: http://www.mars.dti.ne.jp/~umejava/smalltalk/stClasses/smallinterfaces/ (Squeak Port)

"!


Object subclass: #SIClassDefinitionChangedEvent
	instanceVariableNames: 'source aspect selector behavior '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces Squeak Util'!
!SIClassDefinitionChangedEvent commentStamp: 'MU 5/19/2000 14:09' prior: 0!
I am used for carrying class-changed information for SmallInterfaces (in old changed: protocol)
I might to be reconsidered to be used in when:send:to: event mechanism.

---
#creator
[:masashi | ^umezawa] 
#version 2.0 MU 5/12/2000 17:16!


!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:06'!
aspect
	^aspect! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:07'!
aspect: aSymbol
	aspect := aSymbol! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:06'!
behavior
	^behavior! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:07'!
behavior: aBehavior
	behavior := aBehavior! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:06'!
selector
	^selector! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:07'!
selector: aSymbol
	selector := aSymbol! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:05'!
source
	^source! !

!SIClassDefinitionChangedEvent methodsFor: 'accessing' stamp: 'MU 5/4/2000 19:06'!
source: anEventSource
	source := anEventSource! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SIClassDefinitionChangedEvent class
	instanceVariableNames: ''!

!SIClassDefinitionChangedEvent class methodsFor: 'instance creation' stamp: 'MU 5/4/2000 19:09'!
source: anEventrSource aspect: anAspectSymbol
	^self new source: anEventrSource;
				aspect: anAspectSymbol! !


Model subclass: #SIGuiModel
	instanceVariableNames: 'title '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces Squeak Util'!
!SIGuiModel commentStamp: 'MU 5/19/2000 14:10' prior: 0!
I am a simple ApplicationModel(presentaion model) for both MVC and Morphic.

---
#creator
[:masashi | ^umezawa] 
#version 2.0 MU 5/12/2000 17:16!


!SIGuiModel methodsFor: 'initialize-release' stamp: 'MU 4/20/2000 00:11'!
initialize! !


!SIGuiModel methodsFor: 'menu actions' stamp: 'MU 4/22/2000 00:47'!
perform: menuCallBack orSendTo: otherTarget 
	
	self  perform: menuCallBack.
	! !


!SIGuiModel methodsFor: 'private' stamp: 'MU 4/22/2000 00:05'!
privBuildMenu: aCustomMenu with: aMenuArray
	"Morhic now supoort #- syntax?? ##??"
	aCustomMenu addList: aMenuArray.
	^aCustomMenu! !


!SIGuiModel methodsFor: 'accessing' stamp: 'MU 5/7/2000 23:13'!
title
	^title! !

!SIGuiModel methodsFor: 'accessing' stamp: 'MU 5/7/2000 23:13'!
title: aString
	title := aString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SIGuiModel class
	instanceVariableNames: ''!

!SIGuiModel class methodsFor: 'interface opening' stamp: 'MU 5/6/2000 23:22'!
open
	Smalltalk isMorphic
		ifTrue: [self openInMorphic]
		ifFalse: [self openInMVC].! !

!SIGuiModel class methodsFor: 'interface opening' stamp: 'MU 5/6/2000 23:04'!
openInMVC! !

!SIGuiModel class methodsFor: 'interface opening' stamp: 'MU 5/6/2000 23:06'!
openInMorphic! !


!SIGuiModel class methodsFor: 'instance creation' stamp: 'MU 4/20/2000 00:10'!
new
	^super new initialize! !


!SIGuiModel class methodsFor: 'builder' stamp: 'MU 5/8/2000 00:40'!
buildButtonViewBy: aViewClass label: aString action: anActionBlock
	| view button |
	button := Button new.
	button onAction: anActionBlock.
	view := aViewClass on: button.
	view label: aString.
	^view! !


SIGuiModel subclass: #SIDialog
	instanceVariableNames: 'response isDone acceptBlock cancelBlock list listIndex listSelections valueList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces Squeak Util'!
!SIDialog commentStamp: 'MU 5/14/2000 00:08' prior: 0!
I am a Dialog facade. I pretend to be a VW style Dialog.

---
#creator
[:masashi | ^umezawa] 
#version 2.0 MU 5/12/2000 17:16!


!SIDialog methodsFor: 'initialize-release' stamp: 'MU 4/22/2000 00:31'!
initialize
	acceptBlock := cancelBlock := [:arg | ].
	isDone := false.
	! !


!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:18'!
acceptBlock
	^acceptBlock! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:18'!
acceptBlock: aValue
	acceptBlock := aValue
	! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:19'!
cancelBlock
	^cancelBlock! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:19'!
cancelBlock: aValue
	cancelBlock := aValue
	! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:22'!
isDone
	^isDone! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/21/2000 23:41'!
list: anIndexableCollection
	list := anIndexableCollection! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:17'!
response
	^response! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/22/2000 00:17'!
response: aValue
	response := aValue
	! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/21/2000 23:48'!
valueList
	valueList isNil ifTrue:[valueList := Array new.].
	^valueList! !

!SIDialog methodsFor: 'accessing' stamp: 'MU 4/21/2000 23:41'!
valueList: anIndexableCollection
	valueList := anIndexableCollection! !


!SIDialog methodsFor: 'actions' stamp: 'MU 5/7/2000 00:33'!
accept
	self response: (self acceptBlock value: self).
	self changed: #accept.
	self done! !

!SIDialog methodsFor: 'actions' stamp: 'MU 4/22/2000 00:19'!
cancel
	self response: (self cancelBlock value: self).
	self changed: #cancel.
	self done
	! !

!SIDialog methodsFor: 'actions' stamp: 'MU 4/22/2000 00:16'!
done
	isDone := true.! !


!SIDialog methodsFor: 'list actions' stamp: 'MU 5/12/2000 16:31'!
deselectAll
	1 to: self listSelections size do:[:idx | self listSelectionAt: idx put: false].
	listIndex := 0.
	self changed: #list.
	self changed: #listIndex.
	self contentsChanged! !

!SIDialog methodsFor: 'list actions' stamp: 'MU 5/12/2000 16:31'!
selectAll
	1 to: self listSelections size do:[:idx | self listSelectionAt: idx put: true].
	self changed: #list.
	self contentsChanged! !

!SIDialog methodsFor: 'list actions' stamp: 'MU 4/22/2000 00:40'!
selectedListElementValues
	| values |
	values := OrderedCollection new.
	self listSelections with: self valueList
		do: [:sele :eachValue | sele ifTrue: [values add: eachValue]].
	^values! !


!SIDialog methodsFor: 'list callback' stamp: 'MU 4/21/2000 23:47'!
list
	list isNil ifTrue:[list := Array new.].
	^list! !

!SIDialog methodsFor: 'list callback' stamp: 'MU 4/22/2000 01:16'!
listIndex
	listIndex isNil ifTrue:[listIndex := 0.].
	^listIndex! !

!SIDialog methodsFor: 'list callback' stamp: 'MU 4/21/2000 23:48'!
listSelectionAt: index
	^ self listSelections at: index! !

!SIDialog methodsFor: 'list callback' stamp: 'MU 4/21/2000 23:49'!
listSelectionAt: index put: aBoolean
	^self listSelections at: index put: aBoolean! !

!SIDialog methodsFor: 'list callback' stamp: 'MU 4/21/2000 23:50'!
listSelections
	listSelections isNil ifTrue:[listSelections := Array new: self list size withAll: false].
	^ listSelections! !

!SIDialog methodsFor: 'list callback' stamp: 'MU 4/22/2000 00:53'!
toggleListIndex: anIndex
	listIndex ~= 0 ifTrue: [self listSelections at: listIndex put: false].
	anIndex ~= 0 ifTrue: [self listSelections at: anIndex put: true].
	listIndex := anIndex.
	self changed: #listIndex.
	self contentsChanged! !


!SIDialog methodsFor: 'menu' stamp: 'MU 4/22/2000 00:07'!
listMenu: aCustomMenu 
	^self privBuildMenu: aCustomMenu with: self class listMenuArray! !

!SIDialog methodsFor: 'menu' stamp: 'MU 4/22/2000 00:19'!
listMenuTitle
	^self class listMenuTitle! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SIDialog class
	instanceVariableNames: ''!

!SIDialog class methodsFor: 'actions' stamp: 'MU 5/12/2000 19:24'!
chooseMultiple: messageString from: candidates
	^self chooseMultiple: messageString fromList: candidates values: candidates! !

!SIDialog class methodsFor: 'actions' stamp: 'MU 5/12/2000 18:42'!
chooseMultiple: messageString fromList: candidates values: candidateValues
	| model window |
	model := self new.
	model title: messageString.
	model list: (candidates collect:[:each | each asString]).
	model valueList: candidateValues.
	model acceptBlock:[:m | m selectedListElementValues].
	model cancelBlock:[:m | #()].
	window := self buildMultiSelectionChooserWindow: messageString on: model.
	self privWaitOpen: window with: model.
	^ model response! !

!SIDialog class methodsFor: 'actions' stamp: 'MU 4/20/2000 00:21'!
confirm: queryString 
	^PopUpMenu confirm: queryString! !

!SIDialog class methodsFor: 'actions' stamp: 'MU 4/20/2000 00:21'!
request: aString
	^FillInTheBlank request: aString! !

!SIDialog class methodsFor: 'actions' stamp: 'MU 5/12/2000 19:17'!
request: aQueryString initialAnswer: aDefaultString
	^FillInTheBlank request: aQueryString initialAnswer: aDefaultString! !

!SIDialog class methodsFor: 'actions' stamp: 'MU 4/20/2000 00:20'!
warn: aString
	^self inform: aString! !


!SIDialog class methodsFor: 'builder' stamp: 'MU 4/21/2000 19:40'!
buildButtonRowOn: aModel 
	| b spacer buttonRow |
	b := SimpleButtonMorph new target: aModel;
			 color: Color veryLightGray.
	spacer := AlignmentMorph newSpacer: Color white.
	buttonRow := AlignmentMorph newRow borderWidth: 0;
			 inset: 3;
			 color: Color white;
			 hResizing: #spaceFill;
			 vResizing: #shrinkWrap.
	buttonRow addMorphBack: spacer fullCopy;
	 addMorphBack: (b fullCopy label: 'Accept(s)';
		 actionSelector: #accept);
	 addMorphBack: spacer fullCopy;
	 addMorphBack: (b fullCopy label: 'Cancel(l)';
		 actionSelector: #cancel);
	 addMorphBack: spacer fullCopy.
	^ buttonRow.! !

!SIDialog class methodsFor: 'builder' stamp: 'MU 5/7/2000 23:19'!
buildMultiSelectionChooserWindow: title on: model 
	
	| window |
	window := Smalltalk isMorphic
		ifTrue: [self privBuildMorphMultiSelectionChooserOn: model]
		ifFalse: [self privBuildMVCMultiSelectionChooserOn: model].
	
	^ window.! !

!SIDialog class methodsFor: 'builder' stamp: 'MU 4/21/2000 23:52'!
buildPluggableMultiSelectionListViewBy: aViewClass on: aModel
	| view |
	view := aViewClass on: aModel
			list: #list
			selected: #listIndex
			changeSelected: #toggleListIndex:
			menu: #listMenu:.
	view  menuTitleSelector: #listMenuTitle.
	^view! !


!SIDialog class methodsFor: 'constants' stamp: 'MU 4/21/2000 23:55'!
listMenuTitle
	^'list menu'! !


!SIDialog class methodsFor: 'menu arrays' stamp: 'MU 4/22/2000 00:11'!
listMenuArray
	^#(
	('select all' #selectAll)
	('deselect all' #deselectAll)
	)! !


!SIDialog class methodsFor: 'private' stamp: 'MU 5/12/2000 16:24'!
privBuildMVCButtonRow: view on: model 
	| rowView b1 b2 |
	rowView := View new.
	b1 := self buildButtonViewBy: PluggableButtonView label: 'OK' action: [model accept.].
	b2 := self buildButtonViewBy: PluggableButtonView label: 'Cancel' action: [model cancel.].
	b1 borderWidth: 1.
	b2 borderWidth: 1.
	rowView 
		addSubView: b1;
		addSubView: b2 toRightOf: b1.
	view addSubView: rowView below: view.
	^rowView
		! !

!SIDialog class methodsFor: 'private' stamp: 'MU 5/13/2000 02:51'!
privBuildMVCMultiSelectionChooserOn: model
	| window enrtyView buttonRowView  wid fView lView |
	wid := (((model title asDisplayText width * 2) ceiling) max: 200).
	window := StandardSystemView new label: model title;
			 minimumSize: wid @ 130;
			maximumSize: wid @ 130.
	enrtyView :=
		self buildPluggableMultiSelectionListViewBy: PluggableListViewOfMany on: model.
	buttonRowView := self privBuildMVCButtonRow: enrtyView on: model.
	enrtyView window: (0 @ 0 corner: wid @ 100).
	buttonRowView window: (0 @ 0 corner: wid @ 30).
	fView := buttonRowView firstSubView.
	lView := buttonRowView lastSubView.
	fView window: (0 @ 0 corner: (wid//2) @ 30).
	lView window: (0 @ 0 corner: (wid//2) @ 30).
	lView align: lView viewport topLeft with: fView viewport topRight.
	window addSubView: enrtyView.
	window addSubView: buttonRowView below: enrtyView.
	^window
	! !

!SIDialog class methodsFor: 'private' stamp: 'MU 5/7/2000 23:04'!
privBuildMorphButtonRowOn: aModel 
	| b spacer buttonRow |
	b := SimpleButtonMorph new target: aModel;
			 color: Color veryLightGray.
	spacer := AlignmentMorph newSpacer: Color white.
	buttonRow := AlignmentMorph newRow borderWidth: 0;
			 inset: 3;
			 color: Color white;
			 hResizing: #spaceFill;
			 vResizing: #shrinkWrap.
	buttonRow addMorphBack: spacer fullCopy;
	 addMorphBack: (b fullCopy label: 'Accept(s)';
		 actionSelector: #accept);
	 addMorphBack: spacer fullCopy;
	 addMorphBack: (b fullCopy label: 'Cancel(l)';
		 actionSelector: #cancel);
	 addMorphBack: spacer fullCopy.
	^ buttonRow.! !

!SIDialog class methodsFor: 'private' stamp: 'MU 5/13/2000 02:51'!
privBuildMorphMultiSelectionChooserOn: model
	| enrtyMorph buttonRowMorph
	window wid |
	window := (SystemWindow labelled: model title)
				model: model.
	enrtyMorph :=
		self buildPluggableMultiSelectionListViewBy: PluggableListMorphOfMany on: model.
	enrtyMorph color: Color white.
	buttonRowMorph := self privBuildMorphButtonRowOn: model.
	window addMorph: enrtyMorph frame: (0 @ 0 corner: 1 @ 0.7).
	window addMorph: buttonRowMorph frame: (0 @ 0.7 corner: 1 @ 1).
	wid := (model title asDisplayText width * 1.5) ceiling max: 200.
	window extent: wid @ 130.
	^ window.
	! !

!SIDialog class methodsFor: 'private' stamp: 'MU 5/13/2000 01:12'!
privWaitOpen: window with: model 
	Smalltalk isMorphic
		ifTrue: 
			[model addDependent: window.
			World addMorph: window centeredNear: Sensor cursorPoint.
			[model isDone]
				whileFalse: [World doOneCycle].
			model removeDependent: window.
			window delete.
			World doOneCycle]
		ifFalse: 
			[| savedArea |
			window model: model.
			window controller: SIModalDialogController new.
			model addDependent: window controller.
			window align: window viewport center with: Sensor cursorPoint.
			savedArea := Form fromDisplay: window windowBox.
			window display.
			window controller startUp.
			model removeDependent: window controller.
			window release.
			savedArea displayOn: Display at: window labelDisplayBox topLeft].
	^ window.! !


ModalController subclass: #SIModalDialogController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces Squeak Util'!
!SIModalDialogController commentStamp: 'MU 5/14/2000 00:09' prior: 0!
I am used for a Modal Dialog support in MVC.

---
#creator
[:masashi | ^umezawa] 
#version 2.0 MU 5/12/2000 17:16!


!SIModalDialogController methodsFor: 'basic control sequence' stamp: 'MU 5/12/2000 16:02'!
controlTerminate

	self close
! !


!SIModalDialogController methodsFor: 'control defaults' stamp: 'MU 5/12/2000 16:04'!
isControlActive

	^ model isDone not
! !

!SIModalDialogController methodsFor: 'control defaults' stamp: 'MU 5/12/2000 16:08'!
isControlWanted

	^self viewHasCursor and:[ model isDone not]! !


!SIModalDialogController methodsFor: 'updating' stamp: 'MU 5/13/2000 01:12'!
update: anAspect 
	"shameless brute force"
	(anAspect == #accept or: [anAspect == #cancel])
		ifTrue: [self view subViews do: [:each | each release]]! !


Object subclass: #SIParserUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces Squeak Util'!
!SIParserUtil commentStamp: 'MU 5/19/2000 14:10' prior: 0!
I am temporarily used for parsing Smalltalk method sourse code.
I should be replased by RBParser (RBParser in Squeak will be available soon, I hope).

---
#creator
[:masashi | ^umezawa] 
#version 2.0 MU 5/12/2000 17:16!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SIParserUtil class
	instanceVariableNames: ''!

!SIParserUtil class methodsFor: 'parsing' stamp: 'MU 5/6/2000 16:19'!
parseMethodCommentOf: codeString
	"ugly but fast"
	| stream char comment nextchar status |
	status := #outString.
	comment := WriteStream on: ''.
	stream := ReadWriteStream with: codeString.
	stream nextPut: Character space.
	stream reset.
	nextchar := stream next.
	[stream atEnd]
		whileFalse: 
			[char := nextchar.
			nextchar := stream next.
			status == #outString
				ifTrue: 
					[char == $' ifTrue: [status := #inString].
					char == $" ifTrue: [status := #inComment].
					char == $$ ifTrue: [status := #inChar]]
				ifFalse: [status == #doubleQuote
						ifTrue: [status := #inComment]
						ifFalse: [status == #inString
								ifTrue: [char == $' ifTrue: [status := #outString]]
								ifFalse: [status == #inComment
										ifTrue: [char == $"
												ifTrue: [^comment contents]
												ifFalse: [comment nextPut: char]]
										ifFalse: [status == #inChar ifTrue: [status := #outString]]]]]].
		^comment contents
	! !

!SIParserUtil class methodsFor: 'parsing' stamp: 'MU 5/6/2000 16:19'!
parseMethodCommentOfWithQuote: codeString
	| str |
	str := self parseMethodCommentOf: codeString.
	^str isEmpty ifTrue:[str] ifFalse:[ '"', str, '"'].! !

!SIParserUtil class methodsFor: 'parsing' stamp: 'MU 5/6/2000 16:19'!
parseMethodHeaderOf: codeString
	| parser |
	parser := Parser new.
	parser parseSelector: codeString.
	^codeString copyFrom:1 to: (parser endOfLastToken min: codeString size)! !

!SIParserUtil class methodsFor: 'parsing' stamp: 'MU 5/6/2000 16:19'!
parseMethodSelectorOf: codeString
	| parser |
	parser := Parser new.
	^parser parseSelector: codeString.! !
